# Tupel-oder-Klasse.py

# Programme zur Praesentation

### ----- Tupel fuer Adressdaten -----
# Tupel sind statisch
# kein Problem mit unterschiedlichen Typen
# (ist hier eigentlich keine gute Idee, geht aber)
ihre_Adresse = ("Gisela",
                "Mueller",
                "Meierstrasse",
                13,
                21077,
                "Hamburg")
# Zugriffsfunktionen unnoetig, geht aber
def Vorname(adresse): return adresse[0]
print(Vorname(ihre_Adresse))
def Hausnummer(adresse): return adresse[3]
print(Hausnummer(ihre_Adresse))
### es geht nicht:
#ihre_Adresse[0]="Jan"

### ----- Klasse fuer Adressdaten -----
# Einheit von Daten und Funktionen
# moeglichst Kapselung (hier wie bekannt eingeschraenkt,
# ggf bei property nachsehen)

class Adresse():
    '''Adressen als Objekte'''

    def __init__(self,
                 vorname="",
                 nachname="",
                 strasse="",
                 hausnummer="",
                 plz="",
                 ort=""):
        self.__vorname=vorname
        self.__nachname=nachname
        self.__strasse=strasse
        self.__hausnummer=hausnummer
        self.__plz=plz
        self.__ort=ort

    def GibAdressDaten(self):
        return (self.__vorname,
                self.__nachname,
                self.__strasse,
                self.__hausnummer,
                self.__plz,
                self.__ort)

    # Beispiele fuer sondierende Methode
    def GibVornamen(self):
        return self.__vorname

    # Beispiel fuer veraendernde Methode
    def AendereAnschrift(self, strasse, hausnummer, plz, ort):
        self.__strasse=strasse
        self.__hausnummer=hausnummer
        self.__plz=plz
        self.__ort=ort


ihre_Adresse = Adresse("Gisela",
                       "Mueller",
                       "Meierstrasse",
                       13,
                       21077,
                       "Hamburg")

print(ihre_Adresse.GibVornamen())

## Und wieder zum Stutzen:
ihre_Adresse.__vorname="Jan"
print(ihre_Adresse.GibVornamen())
print(ihre_Adresse.__vorname)
# Begruendung:
print(ihre_Adresse.__dict__)
## leider geht eben:
ihre_Adresse._Adresse__vorname="Mic"
print(ihre_Adresse.GibVornamen())

